diff --git a/include/configs/M5208EVBE.h b/include/configs/M5208EVBE.h
index 6630377..0b22106 100644
--- a/include/configs/M5208EVBE.h
+++ b/include/configs/M5208EVBE.h
@@ -14,7 +14,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF520x		/* define processor family */
+#define CONFIG_MCF520x	1	/* define processor family */
 #define CONFIG_M5208		/* define processor type */
 
 #define CONFIG_MCFUART
diff --git a/include/configs/M52277EVB.h b/include/configs/M52277EVB.h
index cde7305..2b58045 100644
--- a/include/configs/M52277EVB.h
+++ b/include/configs/M52277EVB.h
@@ -18,7 +18,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF5227x		/* define processor family */
+#define CONFIG_MCF5227x	1	/* define processor family */
 #define CONFIG_M52277		/* define processor type */
 #define CONFIG_M52277EVB	/* M52277EVB board */
 
diff --git a/include/configs/M5235EVB.h b/include/configs/M5235EVB.h
index 0f6e2f7..f2e5154 100644
--- a/include/configs/M5235EVB.h
+++ b/include/configs/M5235EVB.h
@@ -18,7 +18,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF523x		/* define processor family */
+#define CONFIG_MCF523x	1	/* define processor family */
 #define CONFIG_M5235		/* define processor type */
 
 #define CONFIG_MCFUART
diff --git a/include/configs/M5249EVB.h b/include/configs/M5249EVB.h
index ae4fe45..58cf6be 100644
--- a/include/configs/M5249EVB.h
+++ b/include/configs/M5249EVB.h
@@ -18,7 +18,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF52x2			/* define processor family */
+#define CONFIG_MCF52x2	1		/* define processor family */
 #define CONFIG_M5249			/* define processor type */
 
 #define CONFIG_MCFTMR
diff --git a/include/configs/M5253DEMO.h b/include/configs/M5253DEMO.h
index 3a1cbca..767065e 100644
--- a/include/configs/M5253DEMO.h
+++ b/include/configs/M5253DEMO.h
@@ -7,7 +7,7 @@
 #ifndef _M5253DEMO_H
 #define _M5253DEMO_H
 
-#define CONFIG_MCF52x2		/* define processor family */
+#define CONFIG_MCF52x2	1	/* define processor family */
 #define CONFIG_M5253		/* define processor type */
 #define CONFIG_M5253DEMO	/* define board type */
 
diff --git a/include/configs/M5253EVBE.h b/include/configs/M5253EVBE.h
index fabfdb9..0db23b4 100644
--- a/include/configs/M5253EVBE.h
+++ b/include/configs/M5253EVBE.h
@@ -8,7 +8,7 @@
 #ifndef _M5253EVBE_H
 #define _M5253EVBE_H
 
-#define CONFIG_MCF52x2		/* define processor family */
+#define CONFIG_MCF52x2	1	/* define processor family */
 #define CONFIG_M5253		/* define processor type */
 #define CONFIG_M5253EVBE	/* define board type */
 
diff --git a/include/configs/M5272C3.h b/include/configs/M5272C3.h
index 4c84126..1c2981d 100644
--- a/include/configs/M5272C3.h
+++ b/include/configs/M5272C3.h
@@ -17,7 +17,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF52x2		/* define processor family */
+#define CONFIG_MCF52x2	1	/* define processor family */
 #define CONFIG_M5272		/* define processor type */
 
 #define CONFIG_MCFTMR
diff --git a/include/configs/M5275EVB.h b/include/configs/M5275EVB.h
index 4dddab7..596c38f 100644
--- a/include/configs/M5275EVB.h
+++ b/include/configs/M5275EVB.h
@@ -21,7 +21,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF52x2			/* define processor family */
+#define CONFIG_MCF52x2	1		/* define processor family */
 #define CONFIG_M5275			/* define processor type */
 #define CONFIG_M5275EVB			/* define board type */
 
diff --git a/include/configs/M5282EVB.h b/include/configs/M5282EVB.h
index fd970d0..f27d1e7 100644
--- a/include/configs/M5282EVB.h
+++ b/include/configs/M5282EVB.h
@@ -17,7 +17,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define	CONFIG_MCF52x2		/* define processor family */
+#define	CONFIG_MCF52x2	1	/* define processor family */
 #define CONFIG_M5282		/* define processor type */
 
 #define CONFIG_MCFTMR
diff --git a/include/configs/M53017EVB.h b/include/configs/M53017EVB.h
index a100d9f..7baae44 100644
--- a/include/configs/M53017EVB.h
+++ b/include/configs/M53017EVB.h
@@ -18,7 +18,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF5301x		/* define processor family */
+#define CONFIG_MCF5301x	1	/* define processor family */
 #define CONFIG_M53015		/* define processor type */
 
 #define CONFIG_MCFUART
diff --git a/include/configs/M5329EVB.h b/include/configs/M5329EVB.h
index 78ea384..d09c132 100644
--- a/include/configs/M5329EVB.h
+++ b/include/configs/M5329EVB.h
@@ -18,7 +18,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF532x		/* define processor family */
+#define CONFIG_MCF532x	1	/* define processor family */
 #define CONFIG_M5329		/* define processor type */
 
 #define CONFIG_MCFUART
diff --git a/include/configs/M5373EVB.h b/include/configs/M5373EVB.h
index 849c265..d1c5c5a 100644
--- a/include/configs/M5373EVB.h
+++ b/include/configs/M5373EVB.h
@@ -18,7 +18,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF532x		/* define processor family */
+#define CONFIG_MCF532x	1	/* define processor family */
 #define CONFIG_M5373		/* define processor type */
 
 #define CONFIG_MCFUART
diff --git a/include/configs/M54418TWR.h b/include/configs/M54418TWR.h
index 3d7dc1f..d3155e4 100644
--- a/include/configs/M54418TWR.h
+++ b/include/configs/M54418TWR.h
@@ -18,7 +18,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF5441x	/* define processor family */
+#define CONFIG_MCF5441x	1	/* define processor family */
 #define CONFIG_M54418		/* define processor type */
 #define CONFIG_M54418TWR	/* M54418TWR board */
 
diff --git a/include/configs/M54451EVB.h b/include/configs/M54451EVB.h
index 0f4b726..a52a827 100644
--- a/include/configs/M54451EVB.h
+++ b/include/configs/M54451EVB.h
@@ -18,7 +18,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF5445x		/* define processor family */
+#define CONFIG_MCF5445x	1	/* define processor family */
 #define CONFIG_M54451		/* define processor type */
 #define CONFIG_M54451EVB	/* M54451EVB board */
 
diff --git a/include/configs/M54455EVB.h b/include/configs/M54455EVB.h
index 7a55d3c..880684c 100644
--- a/include/configs/M54455EVB.h
+++ b/include/configs/M54455EVB.h
@@ -18,7 +18,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF5445x		/* define processor family */
+#define CONFIG_MCF5445x	1	/* define processor family */
 #define CONFIG_M54455		/* define processor type */
 #define CONFIG_M54455EVB	/* M54455EVB board */
 
diff --git a/include/configs/M5475EVB.h b/include/configs/M5475EVB.h
index e88a6bd..4443ff0 100644
--- a/include/configs/M5475EVB.h
+++ b/include/configs/M5475EVB.h
@@ -18,7 +18,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF547x_8x	/* define processor family */
+#define CONFIG_MCF547x_8x 1	/* define processor family */
 #define CONFIG_M547x		/* define processor type */
 #define CONFIG_M5475		/* define processor type */
 
diff --git a/include/configs/M5485EVB.h b/include/configs/M5485EVB.h
index e412806..35065a0 100644
--- a/include/configs/M5485EVB.h
+++ b/include/configs/M5485EVB.h
@@ -18,7 +18,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF547x_8x	/* define processor family */
+#define CONFIG_MCF547x_8x 1	/* define processor family */
 #define CONFIG_M548x		/* define processor type */
 #define CONFIG_M5485		/* define processor type */
 
diff --git a/include/configs/TASREG.h b/include/configs/TASREG.h
index 5ad9383..e2353f8 100644
--- a/include/configs/TASREG.h
+++ b/include/configs/TASREG.h
@@ -22,7 +22,7 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MCF52x2			/* define processor family */
+#define CONFIG_MCF52x2	1		/* define processor family */
 #define CONFIG_M5249			/* define processor type */
 
 #define CONFIG_MISC_INIT_R      1       /* call misc_init_r()           */
diff --git a/include/configs/astro_mcf5373l.h b/include/configs/astro_mcf5373l.h
index d875753..5803cbc 100644
--- a/include/configs/astro_mcf5373l.h
+++ b/include/configs/astro_mcf5373l.h
@@ -47,7 +47,7 @@
 
 /* it seems not clear yet which processor defines we should use */
 #define CONFIG_MCF537x			/* define processor family */
-#define CONFIG_MCF532x			/* define processor family */
+#define CONFIG_MCF532x	1		/* define processor family */
 #define CONFIG_M5373			/* define processor type */
 #define CONFIG_ASTRO5373L		/* define board type */
 
diff --git a/include/configs/cobra5272.h b/include/configs/cobra5272.h
index 4644369..3cfb54f 100644
--- a/include/configs/cobra5272.h
+++ b/include/configs/cobra5272.h
@@ -31,7 +31,7 @@
  * ---
  */
 
-#define CONFIG_MCF52x2			/* define processor family */
+#define CONFIG_MCF52x2	1		/* define processor family */
 #define CONFIG_M5272			/* define processor type */
 
 /* ---
diff --git a/include/configs/eb_cpu5282.h b/include/configs/eb_cpu5282.h
index bdca705..a986af2 100644
--- a/include/configs/eb_cpu5282.h
+++ b/include/configs/eb_cpu5282.h
@@ -15,7 +15,7 @@
  * High Level Configuration Options (easy to change)                    *
  *----------------------------------------------------------------------*/
 
-#define	CONFIG_MCF52x2			/* define processor family */
+#define CONFIG_MCF52x2	1		/* define processor family */
 #define CONFIG_M5282			/* define processor type */
 
 #define CONFIG_MISC_INIT_R